<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="接受着id" prop="receivedId">
        <el-input v-model="formData.receivedId" placeholder="请输入接受着id" />
      </el-form-item>
      <el-form-item label="发送内容">
        <Editor v-model="formData.content" height="150px" />
      </el-form-item>
      <el-form-item label="消息类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择消息类型">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="是否已读" prop="isRead">
        <el-input v-model="formData.isRead" placeholder="请输入是否已读" />
      </el-form-item>
      <el-form-item label="101为用户 100为月嫂" prop="receivedType">
        <el-select v-model="formData.receivedType" placeholder="请选择101为用户 100为月嫂">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="信息发送时间" prop="fromDate">
        <el-date-picker
          v-model="formData.fromDate"
          type="date"
          value-format="x"
          placeholder="选择信息发送时间"
        />
      </el-form-item>
      <el-form-item label="订单信息" prop="orderId">
        <el-input v-model="formData.orderId" placeholder="请输入订单信息" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as ImPcApi from '@/api/message'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  receivedId: undefined,
  content: undefined,
  type: undefined,
  isRead: undefined,
  receivedType: undefined,
  fromDate: undefined,
  orderId: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ImPcApi.getImPc(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ImPcApi.ImPcVO
    if (formType.value === 'create') {
      await ImPcApi.createImPc(data)
      message.success(t('common.createSuccess'))
    } else {
      await ImPcApi.updateImPc(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    receivedId: undefined,
    content: undefined,
    type: undefined,
    isRead: undefined,
    receivedType: undefined,
    fromDate: undefined,
    orderId: undefined
  }
  formRef.value?.resetFields()
}
</script>
